import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
import java.awt.Color;
import java.net.URI;
import java.net.URL;

public class world  extends World
{
    final int bufferSize = 1000;
    byte[] waveBytes = new byte[bufferSize];
    int writerOffset = 0;
    final int amountAhead = 800;
    int byteOffset = 0;
    int sampleAmount = 402;
    double colorAngle = 0;
    
    InputStream input;
    GreenfootSound sound = new GreenfootSound("Earth.wav");

    boolean played = false;
    
    long previous;
    long current;
    long difference;
    long start;
    int endByte;
    int startByte;
    
    public world()
    {    
        // Create a new world with 20x20 cells with a cell size of 10x10 pixels.
        super(400, 300, 1); 
        
        
        
        try{
            URL path = getClass().getClassLoader().getResource("Earth.wav");
            input = path.openStream();
            input.read(waveBytes);
        }catch (Exception e){
            System.out.println(e);
        }
        
    }
    
    public void act(){
        if(!played){
            sound.play();
            played = true;
            start = System.currentTimeMillis();
        }
        current = System.currentTimeMillis() - start;
        difference = current - previous;
        
        startByte = (int)(current*176374/4000);
        if(startByte%2 == 0){
            startByte++;
        }
        
        previous = current;
        
        try{
            while(writerOffset - startByte < amountAhead){
                waveBytes[writerOffset%bufferSize] = (byte)input.read();
                writerOffset++;
            }
            //previousByteLocation = startByte + sampleAmount;
            //input.read(waveBytes,0,sampleAmount);
        }catch (Exception e){
            System.out.println(e);
        }
        colorAngle += .001;
        getBackground().setColor(new Color(0,0,0,50));
        getBackground().fill();
        getBackground().setColor(new Color((int)(128+127*Math.cos(colorAngle)),
                                           (int)(128+127*Math.cos(colorAngle+Math.PI*2/3)),
                                           (int)(128+127*Math.cos(colorAngle+Math.PI*4/3))));
        
        double amplitude = 0;
        int num = 0;
        double[] ff1 = new double[65536];
        double[] ff2 = new double[65536];
        
        int index = 0;
        
        /*
        for(int i=startByte;i<startByte+131072;i+=2){
            amplitude = 0;
            int amp = 256*waveBytes[i];
            amp += waveBytes[i+1];
            //amp = amp & 32767;
            amplitude = amp;
            amplitude /= 65536;
            ff1[index] = Math.sin(i);
            //ff2[index] = Math.cos(i);
            //amplitude;
            ff2[index] = amplitude;
            index ++;
            //getBackground().fillOval((int)(200-amplitude),(int)(200-amplitude),(int)(amplitude*2),(int)(amplitude*2));
            //System.out.println(realData[i]);
        }
        */
        
        //FFT((short)1,(long)16,ff1,ff2);
        
        
        for(int i=0;i<400;i+=2){
            getBackground().drawLine(i,150+getLoopingByte(startByte+i),i+1,150+getLoopingByte(startByte+i+2));
            
            //getBackground().drawLine(i,150+waveBytes[i],i,150-waveBytes[i]);
            //getBackground().drawLine(i+1,150+waveBytes[i],i+1,150-waveBytes[i]);
        }
        
        
        
        
        
        //getBackground().setColor(new Color(255,255,255,50));
        //getBackground().fill();
        
        
        //System.out.println(startByte + "  :  "+endByte);
    }
    
    public byte getLoopingByte(int ad){
        return waveBytes[ad%bufferSize];
    }
    
    /*
     * This computes an in-place complex-to-complex FFT 
     * x and y are the real and imaginary arrays of 2^m points.
     * dir =  1 gives forward transform
     * dir = -1 gives reverse transform 
       */
    public void FFT(short dir,long m,double[] x,double[] y){
        long n,i,i1,j,k,i2,l,l1,l2;
        double c1,c2,tx,ty,t1,t2,u1,u2,z;

        /* Calculate the number of points */
        n = 1;
        for(i=0;i<m;i++){
            n *= 2;
        }

        /* Do the bit reversal */
        i2 = n >> 1;
        j = 0;
        for(i=0;i<n-1;i++) {
            if (i < j) {
                tx = x[(int)i];
                ty = y[(int)i];
                x[(int)i] = x[(int)j];
                y[(int)i] = y[(int)j];
                x[(int)j] = tx;
                y[(int)j] = ty;
            }
            k = i2;
            while (k <= j) {
                j -= k;
                k >>= 1;
            }
            j += k;
        }

        /* Compute the FFT */
        c1 = -1.0; 
        c2 = 0.0;
        l2 = 1;
        for (l=0;l<m;l++) {
            l1 = l2;
            l2 <<= 1;
            u1 = 1.0; 
            u2 = 0.0;
            for (j=0;j<l1;j++) {
                for (i=j;i<n;i+=l2) {
                    i1 = i + l1;
                    t1 = u1 * x[(int)i1] - u2 * y[(int)i1];
                    t2 = u1 * y[(int)i1] + u2 * x[(int)i1];
                    x[(int)i1] = x[(int)i] - t1; 
                    y[(int)i1] = y[(int)i] - t2;
                    x[(int)i] += t1;
                    y[(int)i] += t2;
                }
                z =  u1 * c1 - u2 * c2;
                u2 = u1 * c2 + u2 * c1;
                u1 = z;
            }
            c2 = Math.sqrt((1.0 - c1) / 2.0);
            if (dir == 1){
                c2 = -c2;
            }
            c1 = Math.sqrt((1.0 + c1) / 2.0);
        }

        /* Scaling for forward transform */
        if (dir == 1) {
            for (i=0;i<n;i++) {
                x[(int)i] /= n;
                y[(int)i] /= n;
            }
        }
    }
}
